<%-- $Id:view_filetype.jsp 3820 2007-10-12 10:03:18Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.DataFileType"
	import="net.sf.basedb.core.Platform"
	import="net.sf.basedb.core.PlatformVariant"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.util.Values"
	import="java.util.Map"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%!
	private static final Item itemType = Item.DATAFILETYPE;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	DataFileType fileType = DataFileType.getById(dc, itemId);
	
	final boolean writePermission = fileType.hasPermission(Permission.WRITE);
	final boolean deletePermission = fileType.hasPermission(Permission.DELETE);
	final boolean isRemoved = fileType.isRemoved();
	final boolean isUsed = isRemoved && fileType.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	%>

	<%@page import="net.sf.basedb.core.PlatformFileType"%>
<%@page import="net.sf.basedb.core.Include"%>
<base:page title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="toolbar.css,headertabcontrol.css,path.css,table.css">
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function deleteItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=DeleteItem&item_id=<%=itemId%>');
		}
		function restoreItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=RestoreItem&item_id=<%=itemId%>');
		}
		function deleteItemPermanently()
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', <%=itemId%>, '&callback=itemDeleted');
		}
		function itemDeleted()
		{
			Main.listItems('<%=ID%>', '<%=itemType.name()%>');
		}
		function showUsingItems()
		{
			Main.showUsingItems('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
		}
		function runPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&item_id=<%=itemId%>', 'RunPlugin'+cmd, 740, 540);
		}
		</script>
	</base:head>
	<base:body>
		<p>
		<p:path>
			<p:pathelement title="Data file types" href="<%="index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=HTML.encodeTags(fileType.getName())%>" />
		</p:path>
		
		<t:tabcontrol id="main" active="properties">
		<t:tab id="properties" title="Properties">
		
		<tbl:toolbar
			>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "edit.gif" : "edit_disabled.gif"%>" 
				onclick="editItem()" 
				title="Edit&hellip;" 
				tooltip="<%=writePermission ? "Edit this data file type" : "You do not have permission to edit this data file type"%>" 
			/>
			<tbl:button 
				disabled="<%=deletePermission ? false : true%>" 
				image="<%=deletePermission ? "delete.gif" : "delete_disabled.gif"%>" 
				onclick="deleteItem()" 
				title="Delete"
				visible="<%=!fileType.isRemoved()%>"
				tooltip="<%=deletePermission ? "Delete this data file type" : "You do not have permission to delete this data file type"%>" 
			/>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "restore.gif" : "restore_disabled.gif"%>" 
				onclick="restoreItem()" 
				title="Restore"
				visible="<%=fileType.isRemoved()%>"
				tooltip="<%=writePermission ? "Restore this data file type" : "You do not have permission to restore this data file type"%>" 
			/>
			<tbl:button 
				image="import.gif" 
				onclick="runPlugin('ImportItem')" 
				title="Import&hellip;" 
				tooltip="Import data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
			/>
			<tbl:button 
				image="export.gif" 
				onclick="runPlugin('ExportItem')" 
				title="Export&hellip;" 
				tooltip="Export data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
			/>
			<tbl:button 
				image="runplugin.gif" 
				onclick="runPlugin('RunPlugin')" 
				title="Run plugin&hellip;" 
				tooltip="Run a plugin" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
			/>
			<tbl:button
				image="help.gif"
				onclick="<%="Main.openHelp('" + ID +"', 'datafiletype.view.properties')"%>"
				title="Help&hellip;"
				tooltip="Get help about this page"
			/>
			</tbl:toolbar>
		<div class="boxedbottom">
			<div class="itemstatus">
				Permissions on this item: 
				<i><%=PermissionUtil.getFullPermissionNames(fileType)%></i>
			</div>
			<%
			if (fileType.isRemoved())
			{
				%>
				<div class="itemstatus">
					<base:icon 
						image="<%=deletePermanentlyPermission ? "deleted.gif" : "deleted_disabled.gif"%>"
						onclick="<%=deletePermanentlyPermission ? "deleteItemPermanently()" : null%>"
						tooltip="<%=deletePermanentlyPermission ? "Permanently delete this item" : null%>"
						visible="<%=isRemoved%>"> This item has been flagged for deletion<br></base:icon>
					<base:icon image="used.gif" 
						onclick="showUsingItems()"
						tooltip="Show the items that are using this one"
						visible="<%=isUsed%>"> This item is used by other items and can't be permanently deleted<br></base:icon>
				</div>
				<%
			}
			%>
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><%=HTML.encodeTags(fileType.getName())%></td>
			</tr>
			<tr>
				<td class="prompt">External ID</td>
				<td><%=HTML.encodeTags(fileType.getExternalId())%></td>
			</tr>
			<tr>
				<td class="prompt">Item type</td>
				<td><%=fileType.getItemType()%></td>
			</tr>
			<tr>
				<td class="prompt">File extension</td>
				<td><%=HTML.encodeTags(fileType.getExtension())%></td>
			</tr>
			<tr>
				<td class="prompt">Generic file type</td>
				<td><base:propertyvalue item="<%=fileType%>" property="genericType" /></td>
			</tr>
			<tr>
				<td class="prompt">Validator</td>
				<td><%=HTML.encodeTags(fileType.getValidatorClass())%></td>
			</tr>
			<tr>
				<td class="subprompt">- jar path</td>
				<td><%=fileType.getValidatorJarPath() == null ? "<i>- internal -</i>" : fileType.getValidatorJarPath()%></td>
			</tr>
			<tr>
				<td class="prompt">Meta data reader</td>
				<td><%=HTML.encodeTags(fileType.getMetadataReaderClass())%></td>
			</tr>
			<tr>
				<td class="subprompt">- jar path</td>
				<td><%=fileType.getMetadataReaderJarPath() == null ? "<i>- internal -</i>" : fileType.getMetadataReaderJarPath()%></td>
			</tr>
			<tr valign="baseline">
				<td class="prompt">Description</td>
				<td><%=HTML.niceFormat(fileType.getDescription())%></td>
			</tr>
			</table>
			
		</div>
			</t:tab>
			</t:tabcontrol>
			
			<%
			ItemQuery<PlatformFileType> platformQuery = fileType.getPlatforms();
			platformQuery.include(Include.ALL);
			platformQuery.order(Orders.asc(Hql.property("platform.name")));
			ItemResultList<PlatformFileType> platforms = platformQuery.list(dc);
			if (platforms.size() == 0)
			{
				%>
				<h4>Platforms</h4>
				This file type is not used by any platforms or variants
				(or, you don't have permission to view them).
				<%
			}
			else
			{
				%>
				<h4 class="docked">Used on platforms</h4>
				<tbl:table
					id="platforms"
					clazz="itemlist"
					columns="all"
					>
				<tbl:columndef 
					id="platform"
					title="Platform"
				/>
				<tbl:columndef 
					id="variant"
					title="Variant"
				/>
				<tbl:columndef 
					id="required"
					title="Required"
				/>
				<tbl:data>
					<tbl:columns>
					</tbl:columns>
					<tbl:rows>
					<%
					for (PlatformFileType item : platforms)
					{
						Platform p = item.getPlatform();
						PlatformVariant v = item.getVariant();
						%>
						<tbl:row>
							<tbl:cell column="platform"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=p.isRemoved()%>"
								/><%=Base.getLinkedName(ID, p, false, true)%></tbl:cell>
							<tbl:cell column="variant"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=v!= null && v.isRemoved()%>"
								/><%=v == null ? "<i>- all -</i>" : Base.getLinkedName(ID, v, false, true)%></tbl:cell>
							<tbl:cell column="required"><%=item.isRequired() ? "yes" : "no"%></tbl:cell>
						</tbl:row>
						<%
					}
					%>
					</tbl:rows>
				</tbl:data>
				</tbl:table>
				<%
			}
			%>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
