<%-- $Id:list_platforms.jsp 3820 2007-10-12 10:03:18Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Platform"
	import="net.sf.basedb.core.PlatformVariant"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
	import="java.util.Map"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%!
	private static final Item itemType = Item.PLATFORM;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final boolean createPermission = sc.hasPermission(Permission.CREATE, itemType);
final boolean writePermission = sc.hasPermission(Permission.WRITE, itemType);
final boolean deletePermission = sc.hasPermission(Permission.DELETE, itemType);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);

final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final String callback = request.getParameter("callback");
final String title = mode.generateTitle("platform", "platforms");
final DbControl dc = sc.newDbControl();
ItemResultIterator<Platform> platforms = null;
try
{
	// Query for variants of a platform
	final ItemQuery<PlatformVariant> variantQuery = PlatformVariant.getQuery();
	variantQuery.include(cc.getInclude());
	variantQuery.restrict(Restrictions.eq(Hql.property("platform"), Expressions.parameter("platform")));
	variantQuery.order(Orders.asc(Hql.property("name"))); 
	final boolean createVariantPermission = sc.hasPermission(Permission.CREATE, Item.PLATFORMVARIANT); 	

	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	try
	{
		final ItemQuery<Platform> query = Base.getConfiguredQuery(cc, true, Platform.getQuery(), mode);
		platforms = query.iterate(dc);
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
	}
	int numListed = 0;
	%>
	<base:page title="<%=title==null ? "Platforms" : title%>" type="<%=mode.getPageType()%>">
	<base:head scripts="menu.js,table.js" styles="menu.css,table.css">
		<script language="JavaScript">
		var submitPage = 'index.jsp';
		var formId = 'platforms';
		function newItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', 0, true);
		}
		function editItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', itemId, true);
		}
		function viewItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', itemId, false);
		}
		function itemOnClick(evt, itemId)
		{
			Table.itemOnClick(formId, evt, itemId, '<%=mode.getName()%>', viewItem, editItem, returnSelected);
		}
		function deleteItems()
		{
			var frm = document.forms[formId];
			if (Forms.numChecked(frm) == 0)
			{
				alert('Please select at least one item in the list');
				return; 
			}
			frm.action = submitPage;
			frm.cmd.value = 'DeleteItems';
			frm.submit();
		}
		function restoreItems()
		{
			var frm = document.forms[formId];
			if (Forms.numChecked(frm) == 0)
			{
				alert('Please select at least one item in the list');
				return; 
			}
			frm.action = submitPage;
			frm.cmd.value = 'RestoreItems';
			frm.submit();
		}
		function deleteItemPermanently(itemId)
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', itemId);
		}
		function configureColumns()
		{
			Table.configureColumns('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>');
		}
		function runPlugin(cmd)
		{
			Table.submitToPopup(formId, cmd, 740, 540);
		}
		function returnSelected()
		{
			Table.returnSelected(formId, <%=callback != null ? "window.opener."+callback : "null" %>);
			window.close();
		}
		function presetOnChange()
		{
			Table.presetOnChange('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>');
		}
		function newVariant(platformId)
		{
			Main.viewOrEditItem('<%=ID%>', 'PLATFORMVARIANT', 0, true, '&platform_id='+platformId);
		}
		</script>
	</base:head>
	
	<base:body>
		<%
		if (cc.getMessage() != null)
		{
			%>
			<div class="error"><%=cc.getMessage()%></div>
			<%
			cc.setMessage(null);
		}
		%>
		<tbl:table 
			id="platforms" 
			clazz="itemlist" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			title="<%=title%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			>
			<tbl:hidden 
				name="mode" 
				value="<%=mode.getName()%>" 
			/>
			<tbl:hidden 
				name="callback" 
				value="<%=callback%>" 
				skip="<%=callback == null%>" 
			/>
			<tbl:columndef 
				id="name"
				property="name"
				datatype="string"
				title="Name"
				sortable="true" 
				filterable="true"
				exportable="true"
				show="always" 
			/>
			<tbl:columndef 
				id="id"
				clazz="uniquecol"
				property="id"
				datatype="int"
				title="ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="externalId"
				clazz="uniquecol"
				property="externalId"
				datatype="string"
				title="External ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="fileOnly"
				property="fileOnly"
				datatype="boolean"
				title="File-only"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="rawDataType"
				property="rawDataType"
				datatype="string"
				title="Raw data type"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="channels"
				property="channels"
				datatype="int"
				title="Channels"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef
				id="variants"
				title="Variants"
				property="&variants(name)"
				datatype="string"
				filterable="true"
			/>
			<tbl:columndef 
				id="description"
				property="description"
				datatype="string"
				title="Description" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>
			<tbl:toolbar
				visible="<%=mode.hasToolbar()%>"
				>
				<tbl:button 
					disabled="<%=createPermission ? false : true%>" 
					image="<%=createPermission ? "new.gif" : "new_disabled.gif"%>" 
					onclick="newItem()" 
					title="New&hellip;" 
					tooltip="<%=createPermission ? "Create platforms" : "You do not have permission to create platforms"%>" 
				/>
				<tbl:button 
					disabled="<%=deletePermission ? false : true%>" 
					image="<%=deletePermission ? "delete.gif" : "delete_disabled.gif"%>" 
					onclick="deleteItems()" 
					title="Delete" 
					tooltip="<%=deletePermission ? "Delete the selected items" : "You do not have permission to delete platforms" %>" 
				/>
				<tbl:button 
					disabled="<%=writePermission ? false : true%>" 
					image="<%=writePermission ? "restore.gif" : "restore_disabled.gif"%>" 
					onclick="restoreItems()" 
					title="Restore" 
					tooltip="<%=writePermission ? "Restore the selected (deleted) items" : "You do not have permission to edit platforms" %>" 
				/>
				<tbl:button 
					image="columns.gif" 
					onclick="configureColumns()" 
					title="Columns&hellip;" 
					tooltip="Show, hide and re-order columns" 
				/>
				<tbl:button 
					image="import.gif" 
					onclick="runPlugin('ImportItems')" 
					title="Import&hellip;" 
					tooltip="Import data" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
				/>
				<tbl:button 
					image="export.gif" 
					onclick="runPlugin('ExportItems')" 
					title="Export&hellip;" 
					tooltip="Export data" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
				/>
				<tbl:button 
					image="runplugin.gif" 
					onclick="runPlugin('RunListPlugin')" 
					title="Run plugin&hellip;" 
					tooltip="Run a plugin" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
				/>
			</tbl:toolbar>
			<tbl:navigator
				page="<%=cc.getPage()%>" 
				rowsperpage="<%=cc.getRowsPerPage()%>" 
				totalrows="<%=platforms == null ? 0 : platforms.getTotalCount()%>" 
				visible="<%=mode.hasNavigator()%>"
			/>
			<tbl:data>
				<tbl:columns>
				<tbl:presetselector 
					clazz="columnheader"
					colspan="3"
					onchange="presetOnChange()"
				/>
				</tbl:columns>

				<tr>
					<tbl:header 
						clazz="index"
						>&nbsp;</tbl:header>
					<tbl:header 
						clazz="check" 
						visible="<%=mode.hasCheck()%>"
						><base:icon 
							image="check_uncheck.gif" 
							tooltip="Check/uncheck all" 
							onclick="Forms.checkUncheck(document.forms[formId])" style="align: left;"
						/></tbl:header>
					<tbl:header 
						clazz="check" 
						visible="<%=mode.hasRadio()%>"
						>&nbsp;</tbl:header>
					<tbl:header 
						clazz="icons" 
						visible="<%=mode.hasIcons()%>"
						>&nbsp;</tbl:header>
					<tbl:propertyfilter />
				</tr>
					
					<tbl:rows>
					<%
					int index = cc.getPage()*cc.getRowsPerPage();
					int selectedItemId = cc.getId();
					if (platforms != null)
					{						
						while (platforms.hasNext())
						{
							Platform item = platforms.next();
							RawDataType rdt = item.getRawDataType();
							int itemId = item.getId();
							String name = HTML.encodeTags(item.getName());
							String tooltip = mode.isSelectionMode() ? 
									"Select this item" : "View this item" + (writePermission ? " (use CTRL, ALT or SHIFT to edit)" : ""); 
							String deletePermanently = "deleteItemPermanently("+itemId+")";
							index++;
							numListed++;
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasCheck()%>"
									><input 
										type="checkbox" 
										name="<%=itemId%>" 
										value="<%=itemId%>" 
										title="<%=name%>" 
										<%=cc.getSelected().contains(itemId) ? "checked" : ""%> 
									></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasRadio()%>"
									><input 
										type="radio" 
										name="item_id" 
										value="<%=itemId%>" 
										title="<%=name%>" 
										<%=selectedItemId == itemId ? "checked" : ""%>
									></tbl:header>
								<tbl:header 
									clazz="icons" 
									visible="<%=mode.hasIcons()%>"
									><base:icon 
										image="<%=deletePermission ? "deleted.gif" : "deleted_disabled.gif"%>"
										onclick="<%=deletePermission ? deletePermanently : null%>"
										tooltip="This item has been scheduled for deletion" 
										visible="<%=item.isRemoved()%>"
									/>&nbsp;</tbl:header>
								<tbl:cell column="name"><div class="link" 
									onclick="itemOnClick(<%=writePermission ? "event" : null%>, <%=itemId%>)"
									title="<%=tooltip%>"><%=name%></div></tbl:cell>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="externalId"><%=item.getExternalId()%></tbl:cell>
								<tbl:cell column="fileOnly"><%=item.isFileOnly() ? "yes" : "no"%></tbl:cell>
								<tbl:cell column="channels"><%=rdt == null ? "N/A" : rdt.getChannels()%></tbl:cell>
								<tbl:cell column="rawDataType">
									<%=item.isFileOnly() ? "N/A" : (rdt == null ? "<i>- any -</i>" : rdt.getName())%>
								</tbl:cell>
								<tbl:cell column="variants">
									<%
									variantQuery.setParameter("platform", itemId, Type.INT);
									try
									{
										String separator = "";
										for (PlatformVariant v : variantQuery.list(dc))
										{
											out.write(separator);
											if (mode.hasPropertyLink())
											{
												out.write(Base.getLinkedName(ID, v, false, mode.hasEditLink()));
											}
											else
											{
												out.write(HTML.encodeTags(v.getName()));
											}
											separator = ", ";
										}
									}
									catch (Throwable t)
									{
										%>
										<div class="error"><%=t.getMessage()%></div>
										<%
									}
									%>
									<base:icon
										image="add.png" 
										onclick="<%="newVariant("+itemId+")"%>" 
										tooltip="Create new variant" 
										visible="<%=mode.hasEditLink() && createVariantPermission %>"
									/>
								</tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
							</tbl:row>
							<%
							}
						}
					%>
					</tbl:rows>
			</tbl:data>
			<%
			if (numListed == 0)
			{
				%>
				<tbl:panel><%=platforms == null || platforms.getTotalCount() == 0 ? "No platforms were found" : "No platforms on this page. Please select another page!" %></tbl:panel>
				<%
			}
			else
			{
				%>
				<tbl:navigator
					page="<%=cc.getPage()%>" 
					rowsperpage="<%=cc.getRowsPerPage()%>" 
					totalrows="<%=platforms == null ? 0 : platforms.getTotalCount()%>" 
					visible="<%=mode.hasNavigator()%>"
					locked="true"
				/>
				<%
			}
			%>
		</tbl:table>
		<base:buttongroup align="center" clazz="fixedatbottom">
			<base:button onclick="returnSelected();" title="Ok" visible="<%=mode.hasOkButton()%>" />
			<base:button onclick="window.close();" title="Cancel" visible="<%=mode.hasCancelButton()%>" />
			<base:button onclick="window.close();" title="Close" visible="<%=mode.hasCloseButton()%>" />
		</base:buttongroup>
		<br><br><br>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (platforms != null) platforms.close();
	if (dc != null) dc.close();
}
%>
