/* $Id: annotations.js 4547 2008-09-26 09:03:04Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	JavaScript functions for the Annotations
	/common/annotations/*

	@author Nicklas
	@version 2.0
*/

var Annotations = new AnnotationsClass();
function AnnotationsClass()
{

	this.loadAnnotateFrame = function(theFrame, ID, itemType, itemId, protocolId)
	{
		var url = getRoot()+'common/annotations/annotate.jsp?ID='+ID;
		url += '&item_type='+itemType+'&item_id='+itemId;
		if (protocolId != undefined && protocolId != null) url += '&protocol_id='+protocolId;
		theFrame.location.href = url;
	}
	
	this.loadInheritFrame = function(theFrame, ID, itemType, itemId, parents)
	{
		var url = getRoot()+'common/annotations/inherit.jsp?ID='+ID+'&item_type='+itemType+'&item_id='+itemId;
		if (parents && parents.length)
		{
			for (var i = 0; i < parents.length; i++)
			{
				url += '&parents='+parents[i];
			}
		}
		theFrame.location.href = url;
	}

	this.addModifiedAnnotationsToForm = function(theFrame, frm)
	{
		var modified = new Array();
		for (var i = 0; i < theFrame.Parameters.allParameters.length; i++)
		{
			var at = theFrame.Parameters.allParameters[i];
			if (at.modified)
			{
				modified[modified.length] = at.name;
				for (var j = 0; j < at.values.length; j++)
				{
					Forms.createHidden(frm, at.name, at.values[j]);
					if (at.unitId) Forms.createHidden(frm, 'unit:'+at.name, at.unitId);
				}
			}
		}
		if (frm.modifiedAnnotations)
		{
			frm.modifiedAnnotations.value = modified.join(',');
		}
		else
		{
			Forms.createHidden(frm, 'modifiedAnnotations', modified.join(','));
		}
	}
	
	this.addInheritedAnnotationsToForm = function(theFrame, frm)
	{
		var addedAnnotations = theFrame.Link.getActionIds(1, 'A');
		var removedAnnotations = theFrame.Link.getActionIds(-1, 'A');
		var addedAnnotationSets = theFrame.Link.getActionIds(1, 'AS');
		var removedAnnotationSets = theFrame.Link.getActionIds(-1, 'AS');

		if (frm.addedAnnotations)
		{
			frm.addedAnnotations.value = addedAnnotations.join(',');
		}
		else
		{
			Forms.createHidden(frm, 'addedAnnotations', addedAnnotations.join(','));
		}
		if (frm.removedAnnotations)
		{
			frm.removedAnnotations.value = removedAnnotations.join(',');
		}
		else
		{
			Forms.createHidden(frm, 'removedAnnotations', removedAnnotations.join(','));
		}
		if (frm.addedAnnotationSets)
		{
			frm.addedAnnotationSets.value = addedAnnotationSets.join(',');
		}
		else
		{
			Forms.createHidden(frm, 'addedAnnotationSets', addedAnnotationSets.join(','));
		}
		if (frm.removedAnnotationSets)
		{
			frm.removedAnnotationSets.value = removedAnnotationSets.join(',');
		}
		else
		{
			Forms.createHidden(frm, 'removedAnnotationSets', removedAnnotationSets.join(','));
		}
	}
}

