<%-- $Id: index.jsp 4776 2009-02-19 11:51:49Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg
	Copyright (C) 2007 Johan Enell

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------
	This is the welcome page once the user has logged in to BASE.
	It should do a lot more than display an empty page....

	...To be done....

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Message"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.News"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.Quota"
	import="net.sf.basedb.core.QuotaType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Expression"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.util.Values"
	import="java.util.Date"
%>
<%@ taglib
	prefix="base" uri="/WEB-INF/base.tld"
%>
<%!
private String getPrintableQuota(long myQuota, long groupQuota)
{
	String printable = "";
	if (myQuota == Quota.UNDEFINED && groupQuota == Quota.UNDEFINED)
	{
		// Both are undefined
		printable = "";
	}
	else if (myQuota < 0 && groupQuota < 0)
	{
		// both are unlimited or one is unlimited and the other is undefined
		printable = "unlimited";
	}
	else if (myQuota >= 0 && groupQuota >= 0)
	{
		// both are well-defined; use min value
		printable = Values.formatBytes(Math.min(myQuota, groupQuota));
	}
	else
	{
		// Only one is well-defined; use max value
		printable = Values.formatBytes(Math.max(myQuota, groupQuota));
	}
	return printable;
}
%>
<%
SessionControl sc = Base.getExistingSessionControl(pageContext, true);
String ID = sc.getId();

DbControl dc = null;
try
{
	dc = sc.newDbControl();
	User user = User.getById(dc, sc.getLoggedInUserId());
	Quota quota = user.getQuota();
	Group quotaGroup = user.getQuotaGroup();
	Quota groupQuota = quotaGroup == null ? null : quotaGroup.getQuota();
	
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);

	ItemQuery<Message> messageQuery = Message.getQuery(user);
	messageQuery.order(Orders.desc(Hql.property("timeSent")));
	messageQuery.restrict(Restrictions.eq(Hql.property("read"), Expressions.parameter("isread", false)));
	ItemResultList<Message> messages = messageQuery.list(dc);
	
	ItemQuery<Project> projectQuery = Project.getQuery();
	projectQuery.order(Orders.desc(Hql.property("name")));
	projectQuery.include(Include.MINE, Include.SHARED);
	ItemResultList<Project> projects = projectQuery.list(dc);
	
	QuotaType totalQuotaType = QuotaType.getById(dc, SystemItems.getId(QuotaType.TOTAL));
	ItemQuery<QuotaType> quotaTypeQuery = QuotaType.getQuery();
	quotaTypeQuery.order(Orders.asc(Hql.property("id")));
	quotaTypeQuery.restrict(
		Restrictions.neq(
			Hql.property("id"), 
			Hql.entity(totalQuotaType)
		)
	);
	ItemResultList<QuotaType> quotaTypes = quotaTypeQuery.list(dc);

	ItemQuery<News> newsQuery = News.getQuery();
	Expression today = Expressions.parameter("today");
	newsQuery.restrict(Restrictions.lteq(Hql.property("startDate"), today));
	newsQuery.restrict(
		Restrictions.or(
			Restrictions.gteq(Hql.property("endDate"), today),
			Restrictions.eq(Hql.property("endDate"), null)
		)
	);
	newsQuery.order(Orders.desc(Hql.property("newsDate")));
	newsQuery.order(Orders.desc(Hql.property("id")));
	newsQuery.setParameter("today", new Date(), Type.DATE);
	ItemResultList<News> news = newsQuery.list(dc);
%>
<base:page title="Welcome to BASE">
<base:head styles="login.css">

<script language="JavaScript">

	function viewMessage(messageId)
	{
		Main.viewOrEditItem('<%=ID%>', 'MESSAGE', messageId, false);
	}
	function setActiveProject(projectId)
	{
		Main.openPopup('projects/set_active.jsp?ID=<%=ID%>&project_id='+projectId, 'ActivateProject', 300, 140)
	}
</script>

</base:head>
<base:body onload="top.frames['footnote'].location.reload()">


<table border="0" cellspacing="0" cellpadding="0" width="100%">
<tr valign="top">
	<td width="50%">
	
	<h3 class="light docked">
		<base:icon image="project.gif" />
		&nbsp;Projects
	</h3>
		<div id="projects" class="welcomesection">
		<%
		if (projects.size() == 0)
		{
			%>
			You are not member of any projects.
			<%
		}
		else
		{
			int activeProjectId = sc.getActiveProjectId();
			%>
			<table border="0" cellspacing="0" cellpadding="2">
			<%
			if (activeProjectId == 0)
			{
				%>
				<td><base:icon image="warning.gif" /></td>
				<td><i>No active project</i></td>
				<td>&nbsp;</td>			
				<%
			}
			for (Project p : projects)
			{
				int projectId = p.getId();
				if (projectId == activeProjectId)
				{
					%>
					<tr>
						<td><base:icon image="bullet.gif" /></td>
						<td><b><%=Base.getLinkedName(ID, p, false, true)%></b></td>
						<td>[active]</td>
					</tr>
					<%
				}
				else
				{
					%>
					<tr>
						<td>&nbsp;</td>
						<td><%=Base.getLinkedName(ID, p, false, true)%></td>
						<td>[<a href="javascript:setActiveProject(<%=projectId%>)">set active</a>]</td>
					</tr>
					<%
				}
			}
			%>
			</table>
			<%
		}
		%>
		</div>

	<h3 class="light docked"><base:icon image="message.gif" />&nbsp;New messages</h3>
		<div id="messages" class="news welcomesection">
		<%
		String broadcastTitle = (String)application.getAttribute("broadcast.title");
		if (broadcastTitle != null)
		{
			String broadcastMessage = (String)application.getAttribute("broadcast.message");
			%>
			<div class="item"><base:icon image="warning.gif" />
				<span class="date"><%=dateFormatter.format(new Date())%></span>
				<span class="headline"><%=HTML.encodeTags(broadcastTitle)%></span><br>
				<span class="text"><%=HTML.niceFormat(broadcastMessage)%></span>
			</div>
			<% 
		}
		if (messages.size() == 0 && broadcastTitle == null)
		{
			%>
			No new messages.
			<%
		}
		else
		{
			for (Message m : messages)
			{
				String fullName = m.getName();
				String shortName = Values.trimString(fullName, 50);
				String text = Values.trimString(m.getDescription(), 100);
				%>
				<div class="item">
					<a href="javascript:viewMessage(<%=m.getId()%>)"
						title="<%=HTML.encodeTags(fullName)%>">
					<span class="date"><%=dateTimeFormatter.format(m.getTimeSent())%></span>
					<span class="headline"><%=HTML.encodeTags(shortName)%></span></a><br>
					<span class="text"><%=HTML.encodeTags(text)%></span>
				</div>
				<%
			}
		}
		%>
		</div>

	<h3 class="light docked"><base:icon image="diskusage.gif" />&nbsp;Disk usage</h3>
		<div id="quota" class="welcomesection">
		<%
		if (quotaGroup != null)
		{
			%>
			Using quota from group: <%=Base.getLinkedName(ID, quotaGroup, false, true)%>
			<%
		}
		%>
		<table border="0" cellspacing="0" cellpadding="2" width="100%">
		<tr align="center">
			<th>&nbsp;</th>
			<th colspan="2">Primary location</th>
			<th colspan="2">Secondary location</th>
		</tr>
		<tr align="center">
			<th>&nbsp;</th>
			<th>Used</th>
			<th>Assigned</th>
			<th>Used</th>
			<th>Assigned</th>
		</tr>
		<%
			long myPrimaryUsage = user.getDiskUsage(totalQuotaType, Location.PRIMARY);
			long myPrimaryQuota = quota.getQuotaValue(totalQuotaType, Location.PRIMARY);
			long groupPrimaryQuota = groupQuota == null ? Quota.UNDEFINED : groupQuota.getQuotaValue(totalQuotaType, Location.PRIMARY);
			long mySecondaryUsage = user.getDiskUsage(totalQuotaType, Location.SECONDARY);
			long mySecondaryQuota = quota.getQuotaValue(totalQuotaType, Location.SECONDARY);
			long groupSecondaryQuota = groupQuota == null ? Quota.UNDEFINED : groupQuota.getQuotaValue(totalQuotaType, Location.SECONDARY);
		%>
		<tr align="center">
			<th>Total</th>
			<td><%=getPrintableQuota(myPrimaryUsage, Quota.UNDEFINED)%></td>
			<td><%=getPrintableQuota(myPrimaryQuota, groupPrimaryQuota)%></td>
			<td><%=getPrintableQuota(mySecondaryUsage, Quota.UNDEFINED)%></td>
			<td><%=getPrintableQuota(mySecondaryQuota, groupSecondaryQuota)%></td>
		</tr>
		<tr>
			<td colspan="5" style="border-top: 1px dotted #999999"></td>
		</tr>
		<%
		for (QuotaType qt : quotaTypes)
		{
			myPrimaryUsage = user.getDiskUsage(qt, Location.PRIMARY);
			myPrimaryQuota = quota.getQuotaValue(qt, Location.PRIMARY);
			groupPrimaryQuota = groupQuota == null ? Quota.UNDEFINED : groupQuota.getQuotaValue(qt, Location.PRIMARY);
			mySecondaryUsage = user.getDiskUsage(qt, Location.SECONDARY);
			mySecondaryQuota = quota.getQuotaValue(qt, Location.SECONDARY);
			groupSecondaryQuota = groupQuota == null ? Quota.UNDEFINED : groupQuota.getQuotaValue(qt, Location.SECONDARY);
			%>
			<tr style="text-align: center;">
				<th><%=HTML.encodeTags(qt.getName())%></th>
				<td><%=getPrintableQuota(myPrimaryUsage, Quota.UNDEFINED)%></td>
				<td><%=getPrintableQuota(myPrimaryQuota, groupPrimaryQuota)%></td>
				<td><%=getPrintableQuota(mySecondaryUsage, Quota.UNDEFINED)%></td>
				<td><%=getPrintableQuota(mySecondaryQuota, groupSecondaryQuota)%></td>
			</tr>
			<%
		}
		%>
		<tr>
			<td colspan="5" style="border-top: 1px dotted #999999"></td>
		</tr>
		</table>
		&nbsp;<base:icon image="bullet.gif" />&nbsp;<a href="../admin/diskusage/details/index.jsp?ID=<%=ID%>&cmd=ViewItem&item_type=USER&item_id=<%=sc.getLoggedInUserId() %>">View details</a><br>
		</div>
	<%
	String help = Values.getStringOrNull(sc.getClientDefaultSetting("server.links.help"));
	String faq = Values.getStringOrNull(sc.getClientDefaultSetting("server.links.faq"));
	String reportBug = Values.getStringOrNull(sc.getClientDefaultSetting("server.links.reportbug"));
	if (help != null || faq != null || reportBug != null)
	{
		%>
		<h3 class="light docked"><base:icon image="help.gif" />&nbsp;Help</h3>
			<div id="help" class="welcomesection">
			<%
			if (help != null)
			{
				%>
				&nbsp;<base:icon image="bullet.gif" />&nbsp;<a href="<%=help%>" target="Help">Help&hellip;</a><br>
				<%
			}
			%>
			<%
			if (faq != null)
			{
				%>
				&nbsp;<base:icon image="bullet.gif" />&nbsp;<a href="<%=faq%>" target="FAQ">Frequently asked questions&hellip;</a><br>
				<%
			}
			%>
			<%
			if (reportBug != null)
			{
				%>
				&nbsp;<base:icon image="bug.gif" />&nbsp;<a href="<%=reportBug%>" target="ReportBug">Report a bug&hellip;</a><br>
				<%
			}
			%>
			</div>
		<%
	}
	%>
	</td>
	<td>&nbsp;&nbsp;</td>
	<td width="50%">
	
	<h3 class="light docked"><base:icon image="news.gif" />&nbsp;News and announcements</h3>
		<div id="news" class="news welcomesection">
		<%
		if (news.size() == 0)
		{
			%>
			Nothing new.
			<%
		}
		else
		{
			for (News n : news)
			{
				%>
				<div class="item">
					<span class="date"><%=dateFormatter.format(n.getNewsDate())%></span>
					<span class="headline"><%=HTML.encodeTags(n.getName())%></span><br>
					<span class="text"><%=HTML.niceFormat(n.getDescription())%></span>
				</div>
				<%
			}
		}
		%>
		</div>

	</td>
</tr>

</table>

</base:body>
</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
