<%-- $Id: view_experiment.jsp 4767 2009-02-17 14:01:28Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson, Gregory Vincic
	Copyright (C) 2007 Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.Annotation"
	import="net.sf.basedb.core.Annotatable"
	import="net.sf.basedb.core.Unit"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="java.util.Collections"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.HashMap"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.List"
	import="java.util.LinkedList"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%!
	private static final Item itemType = Item.EXPERIMENT;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String tab = Values.getString(request.getParameter("tab"), "properties");
final float scale = Base.getScale(sc);
final String root = request.getContextPath();
final DbControl dc = sc.newDbControl();
try
{
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	Experiment experiment = Experiment.getById(dc, itemId);
	
	final boolean writePermission = experiment.hasPermission(Permission.WRITE);
	final boolean deletePermission = experiment.hasPermission(Permission.DELETE);
	final boolean sharePermission = experiment.hasPermission(Permission.SET_PERMISSION);
	final boolean setOwnerPermission = experiment.hasPermission(Permission.SET_OWNER);
	final boolean isOwner = experiment.isOwner();
	final boolean isRemoved = experiment.isRemoved();
	final boolean isUsed = isRemoved && experiment.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	
	Map<AnnotationType, Set<Object>> usedFactorValues = 
		new HashMap<AnnotationType, Set<Object>>();
	Map<AnnotationType, Integer> factorValuesCount = new HashMap<AnnotationType, Integer>();
	%>

	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function shareItem()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=ShareItem&item_id=<%=itemId%>', 'ShareRawBioAssay', 600, 400);
		}
		function deleteItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=DeleteItem&item_id=<%=itemId%>');
		}
		function restoreItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=RestoreItem&item_id=<%=itemId%>');
		}
		function deleteItemPermanently()
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', <%=itemId%>, '&callback=itemDeleted');
		}
		function itemDeleted()
		{
			Main.listItems('<%=ID%>', '<%=itemType.name()%>');
		}
		function showUsingItems()
		{
			Main.showUsingItems('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
		}		
		function setOwner()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=SetOwnerOfItem&item_id=<%=itemId%>', 'SetOwnerOfItem', 450, 150);
		}
		function runPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&item_id=<%=itemId%>', 'RunPlugin'+cmd, 740, 540);
		}
		function analyzeItem()
		{
			location.href = '<%=root%>/analyze/index.jsp?ID=<%=ID%>&experiment_id=<%=itemId%>';
		}
		function viewBioAssaySets()
		{
			location.href = 'bioassaysets/index.jsp?ID=<%=ID%>&experiment_id=<%=itemId%>';
		}
		function switchTab(tabControlId, tabId)
		{
			if (TabControl.isActive(tabControlId, tabId)) return;
			if (tabId == 'overview' && tabId != '<%=tab%>')
			{
				location.href = 'index.jsp?ID=<%=ID%>&cmd=ViewItem&item_id=<%=itemId%>&tab='+tabId;
			}
			else if (tabId == 'bioassaysets')
			{
				viewBioAssaySets();
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		function editAnnotation(itemType, itemId, annotationTypeId)
		{
			var url = getRoot() + 'common/annotations/annotate.jsp?ID=<%=ID%>';
			url += '&item_type='+itemType;
			url += '&item_id='+itemId;
			url += '&annotationtype_id='+annotationTypeId;
			url += '&standalone=1';
			Main.openPopup(url, 'EditAnnotation', 700, 460);
		}
		function editInheritedAnnotation(itemType, itemId, annotationTypeId)
		{
			var url = getRoot() + 'common/annotations/inherit.jsp?ID=<%=ID%>';
			url += '&item_type='+itemType;
			url += '&item_id='+itemId;
			url += '&annotationtype_id='+annotationTypeId;
			url += '&standalone=1';
			Main.openPopup(url, 'EditAnnotation', 700, 460);
		}
		function setUsedFactorValue(annotationTypeId, values)
		{
			var div = document.getElementById('usedvalues.'+annotationTypeId);
			div.innerHTML = values;
		}
		function showStatus(annotationTypeId, numTotal, numInherited)
		{
			var sss = document.getElementById('status.'+annotationTypeId);
			var html;
			if (numTotal == numInherited)
			{
				html = '<img src="../../images/ok.gif" title="All ' + numTotal + 
					' raw bioassays have a value for this experimental factor">';
			}
			else
			{
				var numMissing = numTotal - numInherited;
				html = '<a href="javascript:autoInherit('+annotationTypeId+')"' + 
					' title="Click for automatic inheritation of annotations from parents">';
				html += '<img src="../../images/warning.gif" border="0">&nbsp;' + numMissing + ' missing</a>';
			}
			sss.innerHTML = html;
		}
		function autoInherit(annotationTypeId)
		{
			var url = 'index.jsp?ID=<%=ID%>&cmd=AutoInherit&item_id=<%=itemId%>&annotationtype_id=' + annotationTypeId;
			Main.openPopup(url, 'AutoInherit', 400, 200);
		}
		</script>
	</base:head>
	<base:body onload="initUsedFactorValues()">
		<p>
		<p:path>
			<p:pathelement title="Experiments" href="<%="index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=HTML.encodeTags(experiment.getName())%>" />
		</p:path>
		
		<t:tabcontrol id="main" active="<%=tab%>" switch="switchTab" remember="false">
		<t:tab id="properties" title="Properties">
		
		<tbl:toolbar
			>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "edit.gif" : "edit_disabled.gif"%>" 
				onclick="editItem()" 
				title="Edit&hellip;" 
				tooltip="<%=writePermission ? "Edit this experiment" : "You do not have permission to edit this experiment"%>" 
			/>
			<tbl:button 
				disabled="<%=deletePermission ? false : true%>" 
				image="<%=deletePermission ? "delete.gif" : "delete_disabled.gif"%>" 
				onclick="deleteItem()" 
				title="Delete"
				visible="<%=!experiment.isRemoved()%>"
				tooltip="<%=deletePermission ? "Delete this experiment" : "You do not have permission to delete this experiment"%>" 
			/>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "restore.gif" : "restore_disabled.gif"%>" 
				onclick="restoreItem()" 
				title="Restore"
				visible="<%=experiment.isRemoved()%>"
				tooltip="<%=writePermission ? "Restore this experiment" : "You do not have permission to restore this experiment"%>" 
			/>
			<tbl:button 
				disabled="<%=sharePermission ? false : true%>"
				image="<%=sharePermission ? "share.gif" : "share_disabled.gif"%>"
				onclick="shareItem()" 
				title="Share&hellip;" 
				tooltip="<%=sharePermission ? "Share this experiment to other user, groups and projects" : "You do not have permission to share this experiment"%>"
			/>
			<tbl:button 
				disabled="<%=setOwnerPermission ? false : true%>"
				image="<%=setOwnerPermission ? "take_ownership.png" : "take_ownership_disabled.png"%>"
				onclick="setOwner()" 
				title="Set owner&hellip;"
				tooltip="<%=setOwnerPermission ? "Change owner of this item" : "You do not have permission to change ownership of this item"%>"
			/>
			<tbl:button 
				image="import.gif" 
				onclick="runPlugin('ImportItem')" 
				title="Import&hellip;" 
				tooltip="Import data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
			/>
			<tbl:button 
				image="export.gif" 
				onclick="runPlugin('ExportItem')" 
				title="Export&hellip;" 
				tooltip="Export data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
			/>
			<tbl:button 
				image="runplugin.gif" 
				onclick="runPlugin('RunPlugin')" 
				title="Run plugin&hellip;" 
				tooltip="Run a plugin" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
			/>
			<tbl:button
				image="help.gif"
				onclick="<%="Main.openHelp('" + ID +"', 'experiment.view.properties')"%>"
				title="Help&hellip;"
				tooltip="Get help about this page"
			/>
			</tbl:toolbar>
		<div class="boxedbottom">
			<div class="itemstatus">Permissions on this item: <i><%=PermissionUtil.getFullPermissionNames(experiment)%></i></div>
			<%
			if (experiment.isRemoved() || experiment.isShared())
			{
				%>
				<div class="itemstatus">
					<base:icon 
						image="<%=deletePermanentlyPermission ? "deleted.gif" : "deleted_disabled.gif"%>"
						onclick="<%=deletePermanentlyPermission ? "deleteItemPermanently()" : null%>"
						tooltip="<%=deletePermanentlyPermission ? "Permanently delete this item" : null%>"
						visible="<%=isRemoved%>"> This item has been flagged for deletion<br></base:icon>
					<base:icon image="used.gif" 
						onclick="showUsingItems()"
						tooltip="Show the items that are using this one"
						visible="<%=isUsed%>"> This item is used by other items and can't be permanently deleted<br></base:icon>
					<base:icon image="shared.gif" 
						visible="<%=experiment.isShared()%>"> This item is shared to other users, groups and/or projects</base:icon>
				</div>
				<%
			}
			%>
			<table class="form" cellspacing="0">
			<tr>
				<td class="prompt">Name</td>
				<td><%=HTML.encodeTags(experiment.getName())%></td>
			</tr>
			<tr>
				<td class="prompt">Registered</td>
				<td><%=dateFormatter.format(experiment.getEntryDate())%></td>
			</tr>
			<tr>
				<td class="prompt">Raw data type</td>
				<td><base:catch><%=HTML.encodeTags(experiment.getRawDataType().getName())%></base:catch></td>
			</tr>
			<tr>
				<td class="prompt">Directory</td>
				<td><base:propertyvalue item="<%=experiment%>" property="directory" /></td>
			</tr>
			<tr>
				<td class="prompt">Bytes</td>
				<td><%=Values.formatBytes(experiment.getBytes())%></td>
			</tr>
			<tr>
				<td class="prompt">Owner</td>
				<td><base:propertyvalue item="<%=experiment%>" property="owner" /></td>
			</tr>
			<tr>
				<td class="prompt">Description</td>
				<td><%=HTML.niceFormat(experiment.getDescription())%></td>
			</tr>
			</table>
			
		<base:section 
			id="publication" 
			title="Publication"
			context="<%=cc%>"
			>
			<table class="form" cellspacing="0">
			<tr>
				<td class="prompt">PubMed ID</td>
				<td>
					<%=HTML.encodeTags(experiment.getPubMedId())%>
					<%
					int pubMedId = Values.getInt(experiment.getPubMedId(), -1);
					if (pubMedId != -1)
					{
						%>
						<b>Link to:</b>
						<a href="http://www.ebi.ac.uk/citexplore/citationDetails.do?externalId=<%=pubMedId%>&dataSource=MED"
							target="_new" title="External link to EBI Citation database"
							>EBI Citation database</a>,
						<a href="http://www.ncbi.nlm.nih.gov/entrez/query.fcgi?cmd=PureSearch&db=pubmed&details_term=<%=pubMedId%>"
							target="_new" title="External link to NCBI Entrez PubMed">NCBI Entrez PubMed</a>
						<%
					}
					%>
				</td>
			</tr>
			<tr>
				<td class="prompt">Title</td>
				<td><%=HTML.niceFormat(experiment.getTitle())%></td>
			</tr>
			<tr>
				<td class="prompt">Publication date</td>
				<td><%=dateFormatter.format(experiment.getPublicationDate())%></td>
			</tr>
			<tr>
				<td class="prompt">Abstract</td>
				<td><%=HTML.niceFormat(experiment.getAbstract())%></td>
			</tr>
			<tr>
				<td class="prompt">Experiment design</td>
				<td><%=HTML.niceFormat(experiment.getExperimentDesign())%></td>
			</tr>
			<tr>
				<td class="prompt">Experiment type</td>
				<td><%=HTML.niceFormat(experiment.getExperimentType())%></td>
			</tr>
			<tr>
				<td class="prompt">Affiliations</td>
				<td><%=HTML.niceFormat(experiment.getAffiliations())%></td>
			</tr>
			<tr>
				<td class="prompt">Authors</td>
				<td><%=HTML.niceFormat(experiment.getAuthors())%></td>
			</tr>
			<tr>
				<td class="prompt">Publication</td>
				<td><%=HTML.niceFormat(experiment.getPublication())%></td>
			</tr>
			</table>
		</base:section>
			
			<%
			ItemQuery<AnnotationType> efQuery = experiment.getExperimentalFactors();
			efQuery.include(Include.ALL);
			efQuery.order(Orders.asc(Hql.property("name")));
			ItemResultList<AnnotationType> experimentalFactors = efQuery.list(dc);
			if (experimentalFactors.size() == 0)
			{
				%>
				<h4>Experimental factors</h4>
				No experimental factors has been added to this experiment 
				(or, you don't have permission to view them).
				<%
			}
			else
			{
				%>
				<base:section 
					id="experimentalFactors" 
					title="<%="Experimental factors (" + experimentalFactors.size() +")"%>"
					context="<%=cc%>">			
				<tbl:table
					id="experimentalFactors"
					clazz="itemlist"
					columns="all"
					>
				<tbl:columndef 
					id="name"
					title="Name"
				/>
				<tbl:columndef
					id="type"
					title="Value type"
				/>
				<tbl:columndef
					id="values"
					title="Used values"
				/>
				<tbl:columndef 
					id="description"
					title="Description"
				/>
				<tbl:columndef 
					id="status"
					title="Status"
				/>
				<tbl:data>
					<tbl:columns>
					</tbl:columns>
					<tbl:rows>
					<%
					for (AnnotationType item : experimentalFactors)
					{
						Type valueType = item.getValueType();
						usedFactorValues.put(item, new HashSet<Object>());
						factorValuesCount.put(item, 0);
						Formatter formatter = FormatterFactory.getTypeFormatter(sc, valueType);
						%>
						<tbl:row>
							<tbl:cell column="name"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=item.isRemoved()%>"
								/><%=Base.getLinkedName(ID, item, false, true)%></tbl:cell>
							<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
							<tbl:cell column="type">
								<%=valueType%>
								<%=item.isEnumeration() ? "(enumeration)" : ""%>
							</tbl:cell>
							<tbl:cell column="values">
								<%
								if (!item.isEnumeration() && (valueType == Type.TEXT || valueType == Type.STRING))
								{
									%>
									N/A
									<%
								}
								else
								{
									%>
									<div id="usedvalues.<%=item.getId()%>">Loading...</div>
									<%
								}
								%>
							</tbl:cell>
							<tbl:cell column="status"><div id="status.<%=item.getId()%>"></div></tbl:cell>
						</tbl:row>
						<%
					}
					%>
					</tbl:rows>
				</tbl:data>
				</tbl:table>
				<base:icon image="warning.gif" /> = Some raw bioassays are missing this factor value;
					click to automatically try to inherit annotations from parents<br>
				<base:icon image="ok.gif" /> = All raw bioassays have a value for this factor
				</base:section>
				<%
			}
			%>
			
			<%
			ItemQuery<RawBioAssay> rbaQuery = experiment.getRawBioAssays();
			rbaQuery.include(Include.ALL);
			rbaQuery.order(Orders.asc(Hql.property("name")));
			ItemResultList<RawBioAssay> rawBioAssays = rbaQuery.list(dc);
			if (rawBioAssays.size() == 0)
			{
				%>
				<h4>Raw bioassays</h4>
				No raw bioassays has been added to this experiment 
				(or, you don't have permission to view them).
				<%
			}
			else
			{
				%>
				<base:section 
					id="rawbioassays" 
					title="<%="Raw bioassays (" + rawBioAssays.size() +")"%>"
					context="<%=cc%>">
				<tbl:table
					id="rawbioassays"
					clazz="itemlist"
					columns="all"
					>
				<tbl:columndef 
					id="name"
					title="Name"
				/>
				<tbl:columndef 
					id="description"
					title="Description"
				/>
				<%
				for (AnnotationType at : experimentalFactors)
				{
					Formatter formatter = FormatterFactory.getTypeFormatter(sc, at.getValueType());
					%>
					<tbl:columndef
						id="<%="at"+at.getId()%>"
						title="<%=HTML.encodeTags(at.getName())%>"
						formatter="<%=formatter%>"
					/>
					<%
				}
				%>
				
				<tbl:data>
					<tbl:columns>
					</tbl:columns>
					<tbl:rows>
					<%
					for (RawBioAssay item : rawBioAssays)
					{
						AnnotationSet as = item.isAnnotated() ? item.getAnnotationSet() : null;
						%>
						<tbl:row>
							<tbl:cell column="name"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=item.isRemoved()%>"
								/><%=Base.getLinkedName(ID, item, false, true)%></tbl:cell>
							<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
							<%
							for (AnnotationType at : experimentalFactors)
							{
								Unit unit = at.getDefaultUnit();
								String unitSymbol = unit == null ? "" : "&nbsp;" + unit.getDisplaySymbol();
								
								String value = "<i>- none -</i>";
								List<Annotation> all = as == null ? null : as.findAnnotations(dc, at, true);
								Map<Annotatable, List> factorValues = new HashMap<Annotatable, List>();
								if (all != null && all.size() > 0)
								{
									for (Annotation a : all)
									{
										List values = a.getValues();
										usedFactorValues.get(at).addAll(values);
										factorValuesCount.put(at, factorValuesCount.get(at)+1);
										Annotatable aItem = null;
										try
										{
											aItem = a.getAnnotationSet().getItem();
										}
										catch (Throwable t)
										{}
										List toAdd = factorValues.get(aItem);
										if (toAdd == null)
										{
											toAdd = new LinkedList();
											factorValues.put(aItem, toAdd);
										}
										toAdd.addAll(values);
									}
								}
								
								%>
								<tbl:cell column="<%="at"+at.getId()%>"
									>
									<%
									for (Map.Entry<Annotatable, List> entry : factorValues.entrySet())
									{
										Annotatable aItem = entry.getKey();
										List values = entry.getValue();
										%>
										<tbl:cellvalue list="<%=values%>" suffix="<%=unitSymbol%>"/>
										<%
										if (aItem != null && aItem.hasPermission(Permission.WRITE))
										{
											%>: <base:icon image="edit.gif" 
												onclick="<%="editAnnotation('"+aItem.getType().name()+"',"+aItem.getId()+","+at.getId()+")"%>" 
												tooltip="Modify the values of this experimental factor" />
											<%
										}
									}
									%>
								</tbl:cell>
								<%
							}
							%>
						</tbl:row>
						<%
					}
					%>
					</tbl:rows>
				</tbl:data>
				</tbl:table>
				</base:section>
				<%
			}
			
			// Tables with users/groups/projects that this item is shared to
			MultiPermissions mp = new MultiPermissions(Collections.singleton(experiment));
			ItemResultIterator<User> users = mp.getUsers().iterate(dc);
			ItemResultIterator<Group> groups = mp.getGroups().iterate(dc);
			ItemResultIterator<Project> projects = mp.getProjects().iterate(dc);
			
			if (users.hasNext() || groups.hasNext() || projects.hasNext())
			{
				%>
				<base:section 
					id="sharedTo" 
					title="Shared to"
					context="<%=cc%>">
				<tbl:table 
					id="itemsSharedTo"
					clazz="itemlist"
					columns="all"
				>
					<tbl:columndef 
						id="itemType"
						title="Item type"
					/>
					<tbl:columndef 
						id="name"
						title="Name"
					/>
					<tbl:columndef 
						id="permissions"
						title="Permissions"
					/>
					<tbl:data>
						<tbl:columns>
						</tbl:columns>
						<tbl:rows>
						<%
						while(projects.hasNext())
						{
							Project project = projects.next();
							Set<Permission> permissions = mp.getPermissions(project).values().iterator().next();
							%>			
							<tbl:row>
								<tbl:cell column="itemType"><%=project.getType()%></tbl:cell>
								<tbl:cell column="name"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=project.isRemoved()%>"
								/><%=Base.getLinkedName(ID, project, false, true)%></tbl:cell>
								<tbl:cell column="permissions">
									<%=PermissionUtil.translatePermissionsToString(permissions)%>
								</tbl:cell>
							</tbl:row>
							<%
						}
						while(groups.hasNext())
						{
							Group group = groups.next();
							Set<Permission> permissions = mp.getPermissions(group).values().iterator().next();
							%>
							<tbl:row>							
								<tbl:cell column="itemType"><%=group.getType()%></tbl:cell>
								<tbl:cell column="name"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=group.isRemoved()%>"
								/><%=Base.getLinkedName(ID, group, false, true)%></tbl:cell>
								<tbl:cell column="permissions">
									<%=PermissionUtil.translatePermissionsToString(permissions)%>
								</tbl:cell>
							</tbl:row>
							<%	
						}
						while (users.hasNext())
						{
							User user = users.next();
							Set<Permission> permissions = mp.getPermissions(user).values().iterator().next();
							%>
							<tbl:row>							
								<tbl:cell column="itemType"><%=user.getType()%></tbl:cell>
								<tbl:cell column="name"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=user.isRemoved()%>"
								/><%=Base.getLinkedName(ID, user, false, true)%></tbl:cell>
								<tbl:cell column="permissions">
									<%=PermissionUtil.translatePermissionsToString(permissions)%>
								</tbl:cell>
							</tbl:row>
							<%
						}
						%>
						</tbl:rows>
					</tbl:data>
				</tbl:table>
				</base:section>
				<%
			}
			else
			{
				%>
				<h4>Shared to</h4>
				This experiment is not shared 
				(or, you don't have permission to view the ones it is shared to).
				<%
			}
			%>
		</div>
		
		<script language="JavaScript">
		function initUsedFactorValues()
		{
			<%
			int numRawBioAssays = rawBioAssays.size();
			for (Map.Entry<AnnotationType, Set<Object>> entry : usedFactorValues.entrySet())
			{
				AnnotationType at = entry.getKey();
				int numRawBioAssaysWithFactor = factorValuesCount.get(at);
				Type valueType = at.getValueType();
				if (at.isEnumeration() || (valueType != Type.TEXT && valueType != Type.STRING))
				{
					Set<Object> values = entry.getValue();
					Formatter formatter = FormatterFactory.getTypeFormatter(sc, valueType);
					Unit unit = at.getDefaultUnit();
					if (unit != null) formatter = unit.getFormatter(formatter);
					String formattedValues = HTML.encodeTags(Values.getString(values, ", ", true, formatter));
					%>
					setUsedFactorValue(<%=at.getId()%>, '<%=HTML.javaScriptEncode(formattedValues)%>');
					showStatus(<%=at.getId()%>, <%=numRawBioAssays%>, <%=numRawBioAssaysWithFactor%>);
					<%
				}
			}
			%>
		}
		</script>
			</t:tab>
			
			<t:tab id="bioassaysets" title="Bioassay sets" />
			<t:tab id="overview" title="Overview" 
				tooltip="Display a tree overview of related items">
				<%
				if ("overview".equals(tab))
				{
					%>
					<jsp:include page="../../common/overview/overview.jsp">
						<jsp:param name="item_type" value="<%=itemType.name()%>" />
						<jsp:param name="item_id" value="<%=itemId%>" />
						<jsp:param name="ID" value="<%=ID%>" />
					</jsp:include>
					<%
				}
				%>
			</t:tab>			
			</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
