<%-- $Id: edit_image.jsp 4511 2008-09-11 20:04:27Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Scan"
	import="net.sf.basedb.core.Image"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.FileType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.IMAGE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final int scanId = Values.getInt(request.getParameter("scan_id"));
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Scan scan = null;
	Image image = null;
	String name = null;
	
	File currentFile = null;
	boolean readCurrentFile = true;

	if (itemId == 0)
	{
		title = "Create image";
		cc.removeObject("item");
		scan = Scan.getById(dc, scanId);
		name = cc.getPropertyValue("name");
		if (name == null) name = scan.getName() + ".i" + (scan.countImages() + 1);
	}
	else
	{
		image = Image.getById(dc, itemId);
		scan = image.getScan();
		name = image.getName();
		cc.setObject("item", image);
		title = "Edit image -- " + HTML.encodeTags(image.getName());
		try
		{
			currentFile = image.getFile();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentFile = false;
		}
	}
	if (image != null && !image.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "Image" tab
		function validateImage()
		{
			var frm = document.forms['image'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['image'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}
		
		function selectFileOnClick()
		{
			var frm = document.forms['image'];
			var url = '../../../filemanager/index.jsp?ID=<%=ID%>&cmd=SelectOne&callback=setFileCallback';
			if (frm.file_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.file_id[1].value));				
				url += '&item_id='+id;
			}
			url += '&filter:INT:fileType=<%=SystemItems.getId(FileType.IMAGE)%>';
			Main.openPopup(url, 'SelectFile', 1000, 700);
		}
		function setFileCallback(fileId, name)
		{
			var frm = document.forms['image'];
			if (frm.file_id.length < 2) // >
			{
				frm.file_id[frm.file_id.length] = new Option();
			}
			frm.file_id[1].value = fileId;
			frm.file_id[1].text = name;
			frm.file_id.selectedIndex = 1;
		}
		
		function init()
		{
			var frm = document.forms['image'];
			<%
			if (image == null)
			{
				%>
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="image" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="scan_id" value="<%=scanId%>">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*220)+"px;"%>" 
			position="bottom" remember="<%=image != null%>">
		<t:tab id="info" title="Image" validate="validateImage()" helpid="image.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(name)%>" 
					size="40" maxlength="<%=Image.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">File</td>
				<td>
					<table border="0" cellspacing="0" cellpadding="0">
					<tr>
					<td>
						<select name="file_id" size="1" 
							<%=!readCurrentFile ? "disabled readonly class=\"disabled\"" : ""%>
							style="width: 20em;">
						<%
						if (!readCurrentFile)
						{
							%>
							<option value="-1">- denied -
							<%
						}
						else
						{
							%>
							<option value="0">- none -
							<%
							if (currentFile != null)
							{
								%>
								<option value="<%=image == null ? currentFile.getId() : -currentFile.getId()%>" 
									selected><%=HTML.encodeTags(currentFile.getName())%>
								<%
							}
						}
						%>
						</select>
						&nbsp;
					</td>
					<td><base:button onclick="selectFileOnClick()" 
						title="Select&hellip;" disabled="<%=!readCurrentFile%>" /></td>
					</tr>
					</table>
				</td>
			</tr>

			<tr>
				<td class="prompt">Format</td>
				<td>
					<select name="format" size="1">
					<%
					Image.Format currentFormat = image != null ? 
						image.getFormat() : Image.Format.fromValue(Values.getInt(cc.getPropertyValue("format")));
					for (Image.Format f : Image.Format.values())
					{
						%>
						<option value="<%=f.name()%>" 
							<%=currentFormat == f ? "selected" : ""%>><%=f.toString()%>
						<%
					}
					%>
					</select>
				</td>
			</tr>

			
			<tr>
				<td class="prompt">Preview</td>
				<td><input type="checkbox" name="preview" value="1"
					<%=(image != null && image.isPreview()) || (image == null && Values.getBoolean(cc.getPropertyValue("preview"))) ? "checked" : ""%>>
				</td>
			</tr>
			
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(image == null ? cc.getPropertyValue("description") : image.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'image', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
